package 
{
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.geom.ColorTransform;
	import flash.geom.Rectangle;
	
	/**
	 * ...
	 * @author HAHA
	 */
	public class Main extends Sprite 
	{
		//physics
		public var redScale:Number = 1;//0~1
		public var greenScale:Number = 1;//0~1
		public var blueScale:Number = 1;//0~1
		
		public var crX:Number = 0;
		public var crY:Number = -50;
		public var cgX:Number = 25*Math.sqrt(3);
		public var cgY:Number = 25;
		public var cbX:Number = -25*Math.sqrt(3);
		public var cbY:Number = 25;
		
		
		//sprite
		public var allSprite:AllSprite;
		
		//control
		public var allControl:AllControl;
		
		
		public function Main():void 
		{
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init);
		}
		
		private function init(e:Event = null):void 
		{
			removeEventListener(Event.ADDED_TO_STAGE, init);
			// entry point
			
			allSprite = new AllSprite();
			allSprite.x = 1024 / 2;
			allSprite.y = 768 / 2;
			this.addChild(allSprite);
			
			
			
			//排位置
			allSprite.btnR.x = crX;
			allSprite.btnR.y = crY;
			allSprite.btnG.x = cgX;
			allSprite.btnG.y = cgY;
			allSprite.btnB.x = cbX;
			allSprite.btnB.y = cbY;
			
			
			//初始顏色
			allSprite.cr.transform.colorTransform = new ColorTransform(1, 0, 0, 1, 0, 0, 0, 0);
			allSprite.cg.transform.colorTransform = new ColorTransform(0, 1, 0, 1, 0, 0, 0, 0);
			allSprite.cb.transform.colorTransform = new ColorTransform(0, 0, 1, 1, 0, 0, 0, 0);
			allSprite.cy.transform.colorTransform = new ColorTransform(1, 1, 0, 1, 0, 0, 0, 0);
			allSprite.cm.transform.colorTransform = new ColorTransform(1, 0, 1, 1, 0, 0, 0, 0);
			allSprite.cc.transform.colorTransform = new ColorTransform(0, 1, 1, 1, 0, 0, 0, 0);
			
			//mask
			allSprite.cy.mask = allSprite.cym;
			allSprite.cm.mask = allSprite.cmm;
			allSprite.cc.mask = allSprite.ccm;
			
			allSprite.whiteMC.mask = allSprite.cwmm;
			allSprite.whiteMC.cw.mask = allSprite.whiteMC.cwm;
			
			//alpha
			allSprite.btnR.alpha = allSprite.btnG.alpha = allSprite.btnB.alpha = 0;
			
			
			
			//control
			allControl = new AllControl();
			allControl.x = 1024 / 2;
			allControl.y = 768 - 200;
			this.addChild(allControl);
			
			
			this.addEventListener(Event.ENTER_FRAME, myshow);
			
			
			//drag
			allSprite.btnR.addEventListener(MouseEvent.MOUSE_DOWN, downBTN);
			allSprite.btnG.addEventListener(MouseEvent.MOUSE_DOWN, downBTN);
			allSprite.btnB.addEventListener(MouseEvent.MOUSE_DOWN, downBTN);
			allSprite.addEventListener(MouseEvent.MOUSE_UP, mouseUP);
			
		}
		
		
		
		public function myshow(e:Event):void {
			
			//對齊
			
			//r
			allSprite.cr.x =allSprite.cym.x =allSprite.cwmm.x =allSprite.cm.x = allSprite.btnR.x;
			allSprite.cr.y =allSprite.cym.y =allSprite.cwmm.y =allSprite.cm.y = allSprite.btnR.y;
			
			//g
			allSprite.cg.x =allSprite.cy.x =allSprite.ccm.x =allSprite.whiteMC.cwm.x = allSprite.btnG.x;
			allSprite.cg.y =allSprite.cy.y =allSprite.ccm.y =allSprite.whiteMC.cwm.y = allSprite.btnG.y;
			
			//b
			allSprite.cb.x =allSprite.cmm.x =allSprite.cc.x =allSprite.whiteMC.cw.x = allSprite.btnB.x;
			allSprite.cb.y =allSprite.cmm.y =allSprite.cc.y =allSprite.whiteMC.cw.y = allSprite.btnB.y;
			
			
			
			//color
			redScale = allControl.slR.value;
			greenScale = allControl.slG.value;
			blueScale = allControl.slB.value;
			
			//設定顏色
			allSprite.cr.transform.colorTransform = new ColorTransform(redScale, 0, 0, 1, 0, 0, 0, 0);
			allSprite.cg.transform.colorTransform = new ColorTransform(0, greenScale, 0, 1, 0, 0, 0, 0);
			allSprite.cb.transform.colorTransform = new ColorTransform(0, 0, blueScale, 1, 0, 0, 0, 0);
			allSprite.cy.transform.colorTransform = new ColorTransform(redScale, greenScale, 0, 1, 0, 0, 0, 0);
			allSprite.cm.transform.colorTransform = new ColorTransform(redScale, 0, blueScale, 1, 0, 0, 0, 0);
			allSprite.cc.transform.colorTransform = new ColorTransform(0, greenScale, blueScale, 1, 0, 0, 0, 0);
			allSprite.whiteMC.cw.transform.colorTransform = new ColorTransform(redScale, greenScale, blueScale, 1, 0, 0, 0, 0);
			
		}
		
		
		public function downBTN(e:MouseEvent):void {
			
			var btnWho = e.target;
			
			btnWho.startDrag(false, new Rectangle(-1024/2, -768/2, 1024, 768));
			
		}
		
		public function mouseUP(e:MouseEvent):void {
			
			allSprite.btnR.stopDrag();
			allSprite.btnG.stopDrag();
			allSprite.btnB.stopDrag();
			
		}
		
	}
	
}